package com.zipcodewilmington.arrayutility;

import java.util.Arrays;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility <T> {

    private T[] array;

    public ArrayUtility(T[] array) {
        this.array = array;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        merge(arrayToMerge);
        int count = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i].equals(valueToEvaluate)) {
                count++;
            }
        }
        return count;
    }
    public T getMostCommonFromMerge(T[] arrayToMerge) {
        merge(arrayToMerge);
        int maxCount = 0;
        T commonValue = null;
        for (int i = 0; i < array.length; i++) {
            T currValue = array[i];
            int currCount = 0;
            for (int j = i + 1; j < array.length; j++) {
                if (array[j].equals(currValue)) currCount++;
            }
            if (currCount > maxCount || commonValue == null) {
                maxCount = currCount;
                commonValue = currValue;
            }
        }
        return commonValue;
    }

    private void merge(T[] arrayToMerge) {
        T[] temp = (T[]) new Object[arrayToMerge.length + array.length];
        for (int i = 0; i < arrayToMerge.length + array.length; i++) {
            if (i < array.length) {
                temp[i] = array[i];
            }
            else {
                temp[i] = arrayToMerge[i - array.length];
            }
        }
        array = temp;
    }


    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        int count = 0;
        for (int i = 0; i < array.length; i++) {
            if (array[i].equals(valueToEvaluate)) {
                count++;
            }
        }
        return count;
    }
    public T[] removeValue(T valueToRemove) {
        int numOccurrences = getNumberOfOccurrences(valueToRemove);
        T[] temp = Arrays.copyOf(array, array.length - numOccurrences);
        int removed = 0;
        for (int i = 0; i < array.length; i++) {
            if (!array[i].equals(valueToRemove)) {
                temp[i - removed] = array[i];
            }
            else removed++;
        }
        array = temp;
        return array;
    }

}
